#include <J3ML/LinearAlgebra/Vector2.h>
#include <J3ML/LinearAlgebra/Vector3.h>

#pragma once

namespace Geometry {
    using Vector2 = LinearAlgebra::Vector2;
    using Vector3 = LinearAlgebra::Vector3;

    class LineSegment2D
    {
        Vector2 A;
        Vector2 B;
    };

    class Rectangle;
    class OBB2D;
    class Line2D;
    class Ray2D;
    class Triangle2D;
    class Polygon2D;


    struct IntersectionResult2D {};

    bool Intersects2D(LineSegment2D seg, Rectangle rect);
    IntersectionResult2D GetIntersection2D(LineSegment2D seg, Rectangle rect);
}