#include <J3ML/LinearAlgebra/AxisAngle.h>
#include <J3ML/LinearAlgebra/Quaternion.h>
namespace LinearAlgebra {

    AxisAngle::AxisAngle() : axis(Vector3::Zero) {}

    AxisAngle::AxisAngle(const Vector3 &axis, float angle) : axis(axis), angle(angle) {}

    Quaternion AxisAngle::ToQuaternion() const {
        return {
                axis.x * std::sin(angle/2),
                axis.y * std::sin(angle/2),
                axis.z * std::sin(angle/2),
                std::cos(angle/2)
        };
    }
}